// -*- C++ -*- generated by wxGlade 0.6.3 on Wed Mar 04 16:53:31 2009

#include "PrecompiledHeader.h"
#include "Misc.h"
#include "frmMain.h"
#include "frmGamefixes.h"

wxMenu* frmMain::MakeLanguagesMenu() const
{
	wxMenu* menuLangs = new wxMenu();
	
	// TODO : Index languages out of the resources and Langs folder.

	menuLangs->Append(Menu_Language_Start, _t("English"), wxEmptyString, wxITEM_RADIO);

	return menuLangs;
}

wxMenu* frmMain::MakeStatesMenu()
{
	wxMenu* mnuStates = new wxMenu();

	m_LoadStatesSubmenu.Append( Menu_State_LoadOther, "Other...", wxEmptyString, wxITEM_NORMAL );
	m_SaveStatesSubmenu.Append( Menu_State_SaveOther, "Other...", wxEmptyString, wxITEM_NORMAL );

	mnuStates->Append( Menu_State_Load, _t("Load"), &m_LoadStatesSubmenu, wxEmptyString );
	mnuStates->Append( Menu_State_Save, _t("Save"), &m_SaveStatesSubmenu, wxEmptyString );
	return mnuStates;
}

wxMenu* frmMain::MakeStatesSubMenu( int baseid ) const
{
	wxMenu* mnuSubstates = new wxMenu();
	wxString slot( _t("Slot") );

	mnuSubstates->Append( baseid,    _t("Slot"), wxEmptyString, wxITEM_NORMAL );
	mnuSubstates->Append( baseid+1,  _t("Slot"), wxEmptyString, wxITEM_NORMAL );
	mnuSubstates->Append( baseid+2,  _t("Slot"), wxEmptyString, wxITEM_NORMAL );
	mnuSubstates->Append( baseid+3,  _t("Slot"), wxEmptyString, wxITEM_NORMAL );
	mnuSubstates->Append( baseid+4,  _t("Slot"), wxEmptyString, wxITEM_NORMAL );
	return mnuSubstates;
}

void frmMain::PopulateVideoMenu()
{
	m_menuVideo.Append( Menu_Video_Basics,	"Basic Settings...",	wxEmptyString, wxITEM_CHECK );
	m_menuVideo.AppendSeparator();

	// Populate options from the plugin here.
	
	m_menuVideo.Append( Menu_Video_Advanced,	"Advanced...",		wxEmptyString, wxITEM_NORMAL );
}

void frmMain::PopulateAudioMenu()
{
	// Populate options from the plugin here.

	m_menuAudio.Append( Menu_Audio_Advanced,	"Advanced...",		wxEmptyString, wxITEM_NORMAL );
}

void frmMain::PopulatePadMenu()
{
	// Populate options from the plugin here.

	m_menuPad.Append( Menu_Pad_Advanced,	"Advanced...",		wxEmptyString, wxITEM_NORMAL );
}

frmMain::frmMain(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxCAPTION|wxCLOSE_BOX|wxSYSTEM_MENU|wxSIMPLE_BORDER),

	m_menubar( *new wxMenuBar() ),
	m_statusbar( *CreateStatusBar(2, 0) ),
	m_background( *new wxStaticBitmap(this, wxID_ANY, wxBitmap(wxT("./pcsxAbout.png"), wxBITMAP_TYPE_PNG) ) ),

	m_menuRun( *new wxMenu() ),
	m_menuConfig( *new wxMenu() ),
	m_menuMisc( *new wxMenu() ),

    m_menuVideo( *new wxMenu() ),
    m_menuAudio( *new wxMenu() ),
    m_menuPad( *new wxMenu() ),
    
	m_LoadStatesSubmenu( *MakeStatesSubMenu( Menu_State_Load01 ) ),
	m_SaveStatesSubmenu( *MakeStatesSubMenu( Menu_State_Save01 ) )
{
    
	// ------------------------------------------------------------------------
	
    m_menuRun.Append(Menu_QuickBootCD,	"Boot CDVD (Quick)",	wxEmptyString, wxITEM_NORMAL);
	m_menuRun.Append(Menu_FullBootCD,	"Boot CDVD (Full)",		wxEmptyString, wxITEM_NORMAL);
	m_menuRun.Append(Menu_BootNoCD,		"Boot without CDVD",	wxEmptyString, wxITEM_NORMAL);
	m_menuRun.Append(Menu_RunELF,		"Run ELF File...",		wxEmptyString, wxITEM_NORMAL);
    m_menuRun.AppendSeparator();

	m_menuRun.Append(Menu_SuspendExec,	_t("Suspend"),	"Suspends emulation progress.", wxITEM_NORMAL);
    m_menuRun.Append(Menu_ResumeExec,	_t("Resume"),	"Resumes emulation progress.", wxITEM_NORMAL);
	m_menuRun.Append(Menu_States,		_t("States"),	MakeStatesMenu(), wxEmptyString);
    m_menuRun.Append(Menu_Reset,		_t("Reset"),	"Resets emulation state and reloads plugins.", wxITEM_NORMAL);

	m_menuRun.AppendSeparator();
	m_menuRun.Append(Menu_Run_Exit,	_t("Exit"), "Closing Pcsx2 may be hazardous to your health", wxITEM_NORMAL);

    // ------------------------------------------------------------------------

	m_menuConfig.Append(Menu_Config_CDVD,		_t("Cdvdrom"),	wxEmptyString, wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_DEV9,		_t("Dev9"),		wxEmptyString, wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_USB,		_t("USB"),		wxEmptyString, wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_FireWire,	_t("Firewire"),	wxEmptyString, wxITEM_NORMAL);

	PopulateVideoMenu();
	PopulateAudioMenu();
	PopulatePadMenu();

	m_menuConfig.AppendSeparator();
	m_menuConfig.Append(Menu_SelectPlugins,	"Plugin Selector...", wxEmptyString, wxITEM_NORMAL);

	m_menuConfig.AppendSeparator();
	m_menuConfig.Append(Menu_Config_Memcards,	_t("Memcards"),		"Memory card file locations and options.", wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_Gamefixes,	_t("Gamefixes"),	"God of War and TriAce fixes are found here.", wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_SpeedHacks,	_t("Speed Hacks"),	"Options to make Pcsx2 emulate faster, but less accurately.", wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_Patches,	_t("Patches"),		wxEmptyString, wxITEM_NORMAL);
	m_menuConfig.Append(Menu_Config_Advanced,	_t("Advanced"),		"Cpu, Fpu, and Recompiler options.", wxITEM_NORMAL);

	// ------------------------------------------------------------------------

	m_menuMisc.Append(Menu_Console,	_t("Enable Console"), wxEmptyString, wxITEM_CHECK);
	m_menuMisc.Append(Menu_Patches,	_t("Enable Patches"), wxEmptyString, wxITEM_CHECK);
	m_menuMisc.Append(Menu_Profiler,_t("Enable Profiler"), wxEmptyString, wxITEM_CHECK);
	m_menuMisc.AppendSeparator();

	// No dialogs implemented for these yet...
	//m_menuMisc.Append(41, "Patch Browser...", wxEmptyString, wxITEM_NORMAL);
	//m_menuMisc.Append(42, "Patch Finder...", wxEmptyString, wxITEM_NORMAL);

	// Ref will want this re-added eventually.
	//m_menuMisc.Append(47, _t("Print CDVD Info..."), wxEmptyString, wxITEM_CHECK);

	m_menuMisc.Append(Menu_Languages,	_t("Languages"),	MakeLanguagesMenu(), wxEmptyString);
	m_menuMisc.AppendSeparator();

	m_menuMisc.Append(Menu_About,		_t("About..."), wxEmptyString, wxITEM_NORMAL);
	m_menuMisc.Append(Menu_Website,		_t("Pcsx2 Website..."), "Opens your web-browser!", wxITEM_NORMAL);

	m_menubar.Append( &m_menuRun,		"Run" );
	m_menubar.Append( &m_menuConfig,	"Config" );
	m_menubar.Append( &m_menuVideo,		"Video" );
	m_menubar.Append( &m_menuAudio,		"Audio" );
	m_menubar.Append( &m_menuPad,		"Pad" );
	m_menubar.Append( &m_menuMisc,		"Misc" );

	SetMenuBar( &m_menubar );

	// The many other fancy portions of our main window!

	set_properties();
}


BEGIN_EVENT_TABLE(frmMain, wxFrame)
	EVT_MENU( Menu_QuickBootCD,	Menu_QuickBootCD_Click )
	EVT_MENU( Menu_FullBootCD,	Menu_BootCD_Click )
	EVT_MENU( Menu_BootNoCD,	Menu_BootNoCD_Click )

	EVT_MENU( Menu_RunELF,		Menu_OpenELF_Click )
	EVT_MENU( Menu_Run_Exit,	Menu_Exit_Click )

	EVT_MENU( Menu_SuspendExec,	Menu_Suspend_Click )
	EVT_MENU( Menu_ResumeExec,	Menu_Resume_Click )
	EVT_MENU( Menu_Reset,		Menu_Reset_Click )

	EVT_MENU( Menu_State_LoadOther,	Menu_LoadStateOther_Click )
	EVT_MENU( Menu_State_SaveOther, Menu_SaveStateOther_Click )

	EVT_MENU( Menu_Config_Gamefixes, Menu_Gamefixes_Click )

END_EVENT_TABLE();


void frmMain::Menu_QuickBootCD_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_BootCD_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_BootNoCD_Click(wxCommandEvent &event)
{
}


void frmMain::Menu_OpenELF_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_LoadStateOther_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_SaveStateOther_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_Exit_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_Suspend_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_Resume_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_Reset_Click(wxCommandEvent &event)
{
}

void frmMain::Menu_Gamefixes_Click( wxCommandEvent& event )
{
	frmGameFixes joe( NULL, wxID_ANY );
	joe.ShowModal();
}


// wxGlade: add frmMain event handlers


void frmMain::set_properties()
{
	wxSize backsize( m_background.GetSize() );

    SetTitle(_("Pcsx2"));
    wxIcon _icon( wxT("./Cdrom02.png"), wxBITMAP_TYPE_PNG );
    SetIcon(_icon);
    SetClientSize( backsize );
    int m_statusbar_widths[] = { (int)(backsize.GetWidth()*0.73), (int)(backsize.GetWidth()*0.25) };
    m_statusbar.SetStatusWidths(2, m_statusbar_widths);
	m_statusbar.SetStatusText( wxT("The Status is Good!"), 0);
	m_statusbar.SetStatusText( wxT("Good Status"), 1);

	wxBoxSizer& joe( *new wxBoxSizer( wxVERTICAL ) );
	
	joe.Add( &m_background );
	SetSizerAndFit( &joe );

	//Layout();
}
